(define-module (ui postfix-dovecot ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :use-module (alterator effect)
    :export (init))

(define (ui-read)
  (form-update-value-list
    (woo-read-first "/postfix-dovecot"))
  (let* ((data (woo-read "/postfix-dovecot"))
         (domain_master (woo-get-option (car data) 'domain_master)))
    (form-update-visibility "nodomain_page" (not domain_master))
    (form-update-activity "main_table"  domain_master)
    (form-update-activity "postfix_daemon"  domain_master)
    (form-update-activity "mode"  domain_master)
    (form-update-activity "relayhost"  domain_master)
    (form-update-activity "domainlist"  domain_master)
    (form-update-activity "relay"  domain_master)
    (form-update-activity "mx"  domain_master)
    (form-update-activity "rootmail"  domain_master)
    (form-update-activity "message_size_limit"  domain_master)
    (form-update-activity "spamfilter"  domain_master)
    (form-update-activity "filter_senders"  domain_master)
    (form-update-activity "mynetworks"  domain_master)
    (form-update-activity "filter_recipients"  domain_master)
    (form-update-activity "filtered_recipients"  domain_master)
    (form-update-activity "pop3_imap"  domain_master)
    (form-update-activity "apply_button"  domain_master)))


(define (ui-write)
  (catch/message
    (lambda()
      (apply woo-write "/postfix-dovecot"
	     'language (form-value "language")
	     (form-value-list))
      (ui-read)
      (update-effect))))

(define (init)
  (form-update-enum "mode"
    (woo-list "/postfix-dovecot/modes" 'language (form-value "language")))

  (ui-read)

  (effect-show "relay" "mode" "relay")
  (effect-show "mx" "mode" "mx")
  (effect-show "recipients" "filter_recipients" #t)
  (init-effect)

  (form-bind "apply_button" "click" ui-write))
